unit unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation,bass,bass_fx;

const
  CostanteM = 86400000;
type
  TForm17 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
        BassInfo: BASS_INFO;
  public
    { Public declarations }
    MemChan : TMemoryStream;
    chan:Dword;
  end;

var
  Form17: TForm17;

implementation

{$R *.fmx}

procedure TForm17.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    MemChan.Free;
    MemChan := TMemoryStream.Create;
    MemChan.LoadFromFile(PChar(OpenDialog1.FileName));
    BASS_ChannelStop(chan);
    Chan := BASS_StreamCreateFile(True, MemChan.memory, 0, MemChan.size, BASS_STREAM_DECODE);
    Chan := BASS_FX_TempoCreate(Chan, BASS_FX_FREESOURCE);
    BASS_ChannelPlay(chan, True);
    Timer1.Enabled:=True;
  end;
end;

procedure TForm17.Button2Click(Sender: TObject);
begin
BASS_ChannelSetPosition(chan, BASS_ChannelSeconds2Bytes(chan, 5), BASS_POS_BYTE);
end;

procedure TForm17.FormCreate(Sender: TObject);
begin
BASS_GetInfo(&BassInfo);
BASS_Init(-1, 48000, BASS_DEVICE_LATENCY,0, nil);

end;

procedure TForm17.Timer1Timer(Sender: TObject);
var posi:Integer;
begin
      posi := Trunc(BASS_ChannelBytes2Seconds(Chan, BASS_ChannelGetPosition(Chan, BASS_POS_BYTE)) * 1000);
      Label1.Text := FormatDateTime('hh:nn:ss.zzz', posi / CostanteM);

end;

end.
